Subject: Re: Bug in "genirq: record trigger type"

From: Benjamin Herrenschmidt <[email-masked]>
Date: Tue, 21 Oct 2008 19:29:54 +1100

On Tue, 2008-10-21 at 01:01 -0700, David Brownell wrote:
> 
> I'm a bit more curious about another potential issue though ... as
> described in the patch comment:
> 
>      - Make set_irq_type() usage match request_irq() usage:
>         * IRQ_TYPE_NONE should be a NOP; succeed, so irq_chip methods
>           won't have to handle that case any more (many do it wrong).
> 
> It might be a bit more accurate to say irq_chip.set_type() methods
> are *inconsistent* in handling IRQ_TYPE_NONE.  Previously the
> set_irq_type() method would pass that down to irq_chip code. 
> 
> I had observed two behaviors, but I thought I observed a third one
> in some of the PowerPC code:
> 
>  (1) ignore it ... matching request_irq() usage
>  (2) return an error ... nasty
>  (3) assign some irq_chip-specific trigger mode
> 
> That third behavior might cause a bit of trouble, but I think
> it was only used during platform init.  Someone more attuned
> to PowerPC might want to check ...

Ok, I wrote a lot of the port of powerpc stuff to genirq so I supposed
I'm the person to do that sweep :-) I'll have a look tomorrow.

Thanks for the heads up,

Cheers,
Ben.